// ******************************************************************************************
// **                                                                                       **
// **      RAYTHEON PROPRIETARY: THIS DOCUMENT CONTAINS DATA OR INFORMATION                 **
// **      PROPRIETARY TO RAYTHEON COMPANY AND IS RESTRICTED TO USE ONLY BY PERSONS         **
// **      AUTHORIZED BY RAYTHEON COMPANY IN WRITING TO USE IT.DISCLOSURE TO                **
// **      UNAUTHORIZED PERSONS WOULD LIKELY CAUSE SUBSTANTIAL COMPETITIVE HARM TO          **
// **      RAYTHEON COMPANY'S BUSINESS POSITION. NEITHER SAID DOCUMENT NOR ITS              **
// **      CONTENTS SHALL BE FURNISHED OR DISCLOSED TO OR COPIED OR USED BY PERSONS         **
// **      OUTSIDE RAYTHEON COMPANY WITHOUT THE EXPRESS WRITTEN APPROVAL OF RAYTHEON        **
// **      COMPANY.                                                                         **
// **                                                                                       **
// **      THIS PROPRIETARY NOTICE IS NOT APPLICABLE IF DELIVERED TO THE U.S.               **
// **      GOVERNMENT.                                                                      **
// **                                                                                       **
// **      UNPUBLISHED WORK - COPYRIGHT RAYTHEON COMPANY.                                   **
// **                                                                                       **
// **      WARNING: THIS DOCUMENT CONTAINS TECHNICAL DATA AND / OR TECHNOLOGY WHOSE         **
// **      EXPORT OR DISCLOSURE TO NON-U.S.PERSONS, WHEREVER LOCATED, IS RESTRICTED         **
// **      BY THE INTERNATIONAL TRAFFIC IN ARMS REGULATIONS (ITAR) (22 C.F.R.SECTION        **
// **      120-130) OR THE EXPORT ADMINISTRATION REGULATIONS(EAR) (15 C.F.R.SECTION         **
// **      730-774). THIS DOCUMENT CANNOT BE EXPORTED(E.G., PROVIDED TO A SUPPLIER          **
// **      OUTSIDE OF THE UNITED STATES) OR DISCLOSED TO A NON-U.S.PERSON, WHEREVER         **
// **      LOCATED, UNTIL A FINAL JURISDICTION AND CLASSIFICATION DETERMINATION HAS         **
// **      BEEN COMPLETED AND APPROVED BY RAYTHEON, AND ANY REQUIRED U.S.GOVERNMENT         **
// **      APPROVALS HAVE BEEN OBTAINED. VIOLATIONS ARE SUBJECT TO SEVERE CRIMINAL          **
// **      PENALTIES.                                                                       **
// **                                                                                       **
// **      CAPITAL EQUIPMENT/SOFTWARE: THIS TECHNICAL DATA WAS DEVELOPED OR ACQUIRED        **
// **      EXCLUSIVELY AT CONTRACTOR EXPENSE AND IS INTENDED FOR USE ON MULTIPLE            **
// **      PROJECTS/PROGRAMS.                                                               **
// **                                                                                       **
// *******************************************************************************************

using Raytheon.Communication;

namespace Raytheon.Instruments
{
   public interface IOscilloScope : IInstrument
   {
      [UmsCommand( "IOscilloScope.IOQuery" )]
      string IOQuery( string command );

      [UmsCommand( "IOscilloScope.IOWrite" )]
      void IOWrite( string command, bool shallWeCheckForError = true );

      [UmsCommand( "IOscilloScope.MeasureFallTime" )]
      double MeasureFallTime( int channelNumber );

      [UmsCommand( "IOscilloScope.MeasureFrequency" )]
      double MeasureFrequency( int channelNumber );

      [UmsCommand( "IOscilloScope.MeasureMaxVoltage" )]
      double MeasureMaxVoltage( int channelNumber );

      [UmsCommand( "IOscilloScope.MeasureMinVoltage" )]
      double MeasureMinVoltage( int channelNumber );

      [UmsCommand( "IOscilloScope.MeasurePulseWidth" )]
      double MeasurePulseWidth( int channelNumber );

      [UmsCommand( "IOscilloScope.MeasureRiseTime" )]
      double MeasureRiseTime( int channelNumber );

      [UmsCommand( "IOscilloScope.MeasureVoltageLevel" )]
      double MeasureVoltageLevel( int channelNumber );

      [UmsCommand( "IOscilloScope.ConfigureChannel" )]
      void ConfigureChannel( int channelNumber, double timePerDivison, double timeOffset, double voltageOffset, double voltageScale, string inputImpedance );

      [UmsCommand( "IOscilloScope.SetupTrigger" )]
      void SetupTrigger( bool useRisingEdge, int channelNumber, double triggerLevel );

      [UmsCommand( "IOscilloScope.HasItTriggered" )]
      bool HasItTriggered( );

      [UmsCommand( "IOscilloScope.SaveImage" )]
      void SaveImage( string fileName );
   }
}
